<script>
import Quatro from './components/Quatro.vue'
import ElgPrintablePage from './components/Printable.vue'

export default {
  name: 'QuatroApp',
  components: { ElgPrintablePage, Quatro},
  data() {
    return { words: [] }
  },
  methods: {
    handleWordSelection({number, hidden, parts}){
      this.words[number-1] = {number, hidden, parts}
    }
  }
}
</script>

<template>
  <div>
    <elg-printable-page v-for="i in 10" class="elg-quatro__grid">
      <quatro v-for="j in 24" :number="(i-1)*24 + j" length="2" @selected="handleWordSelection" />
    </elg-printable-page>

    <h2>Solutions</h2>
    <div class="elg-quatro__solutions">
      <div class="elg-quatro__solution" v-for="entry in words">
        <div>{{entry.number}}</div>
        <div>
          <div>{{entry.parts[0][0]}}<strong>{{entry.hidden}}</strong>{{entry.parts[0][1]}}</div>
          <div>{{entry.parts[1][0]}}<strong>{{entry.hidden}}</strong>{{entry.parts[1][1]}}</div>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.elg-quatro{
  $per-line: 4;

  &__grid {
    display: grid;
    grid-template-columns: repeat($per-line, 1fr);
    gap: var(--printable-page-paddings);
  }

  &__solutions{
    display: grid;
    grid-template-columns: repeat(5, 1fr);
    grid-gap: 1ex;
  }

  &__solution {
    display: grid;
    grid-template-columns: 1.5cm auto;
    grid-gap: 1ex;
    align-items: center;

    > div:first-child {
      text-align: right;
      font-family: monospace;
    }
  }
}
</style>
